//
// *** The Database Update Framework Include file ***
// Language constant declarations for all classes included in "DUF - The Database Update Framework"
// They have all been placed in this central spot to make translations to various languages more convenient.
//
//
Use LanguageText.Pkg

// *** cSQLConnectionsIniFile Class Language Constants ***
//
#IFSAME Language$Current Language$English
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
#ENDIF

#IFSAME Language$Current Language$Nederlands
    Define CS_DUF_DuplicateConnectionIDPre  for "Kan de connection ID niet registreren"
    Define CS_DUF_DuplicateConnectionIDPost for "Deze ID bestaat al."
#ENDIF

#IFSAME Language$Current Language$Svenska
    Define CS_DUF_DuplicateConnectionIDPre  for "Kan inte registrera anslutnings-ID"
    Define CS_DUF_DuplicateConnectionIDPost for "Detta ID finns redan."
#ENDIF

#IFSAME Language$Current Language$Deutsch
    Define CS_DUF_DuplicateConnectionIDPre  for "Kann Connection ID nicht registrieren"
    Define CS_DUF_DuplicateConnectionIDPost for "Dieses ID existiert schon."
#ENDIF

#IFSAME Language$Current Language$Dansk
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
#ENDIF

#IFSAME Language$Current Language$Portugues
    Define CS_DUF_DuplicateConnectionIDPre  for "No pde registar o ID de conexo"
    Define CS_DUF_DuplicateConnectionIDPost for "Este ID j existe."
#ENDIF

#IFSAME Language$Current Language$Francais
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
#ENDIF

#IFSAME Language$Current Language$Italiano
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
#ENDIF

#IFSAME Language$Current Language$Espanol
    Define CS_DUF_DuplicateConnectionIDPre  for "No se puede registrar conexin ID"
    Define CS_DUF_DuplicateConnectionIDPost for "Este ID ya existe."
#ENDIF

#IFSAME Language$Current Language$Norsk
    Define CS_DUF_DuplicateConnectionIDPre  for "Kan ikke registrere tilkoblings-ID"
    Define CS_DUF_DuplicateConnectionIDPost for "Denne ID-en eksisterer allerede."
#ENDIF

#IFSame Language$Current = Language$Russian
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
#ENDIF

#IFSame Language$Current = Language$Polish
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
#ENDIF

#IFSame Language$Current = Language$Hungarian
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
#ENDIF


// *** cSQLConnectionsHandler Class Language Constants ***
//
#IFSAME Language$Current Language$English
    Define CS_DUF_SetupErrorcConnection  for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer    for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText              for "\n\nError Text:"
#ENDIF

#IFSAME Language$Current Language$Nederlands
    Define CS_DUF_CannotLogincConnection for "Kan niet inloggen op de databaseserver, omdat cConnection niet correct is ingesteld. Kan niet doorgaan. Het programma wordt beindigd."
    Define CS_DUF_CannotLoginToServer    for "Kan niet inloggen op de databaseserver. Kan niet doorgaan. Het programma wordt beindigd."
    Define CS_DUF_ErrorText              for "\n\nFoutmelding:"
#ENDIF

#IFSAME Language$Current Language$Svenska
    Define CS_DUF_CannotLogincConnection for "Kan inte logga in p databasservern drfr att en 'cConnection' inte har konfigurerats. Kan ej fortstta. Programmet kommer nu att avbrytas."
    Define CS_DUF_CannotLoginToServer    for "Kunde ej logga in till databasservern. Kan ej fortstta. Programmet kommer nu att avslutas."
    Define CS_DUF_ErrorText              for "\n\nError Text:"
#ENDIF

#IFSAME Language$Current Language$Deutsch
    Define CS_DUF_CannotLogincConnection for "Anmeldung am Datenbank-Server nicht mglich, die cConnection ist nicht richtig eingerichtet. Fortfahren nicht mglich. Das Programm wird beendet."
    Define CS_DUF_CannotLoginToServer    for "Anmeldung am Datenbank-Server nicht mglich. Fortfahren nicht mglich. Das Programm wird beendet."
    Define CS_DUF_ErrorText              for "\n\nFehler Text:"
#ENDIF

#IFSAME Language$Current Language$Dansk
    Define CS_DUF_CannotLogincConnection for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer    for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText              for "\n\nError Text:"
#ENDIF

#IFSAME Language$Current Language$Portugues
    Define CS_DUF_CannotLogincConnection for "No pde conectar-se ao servidor de banco de dados, pois o objeto cConnetion no fora configurado adequadamente. Impossvel continuar. Programa ser encerrado."
    Define CS_DUF_CannotLoginToServer    for "No pde conectar-se ao servidor de banco de dados. Impossvel continuar. Programa ser encerrado."
    Define CS_DUF_ErrorText              for "\n\nDescrio do Erro:"
#ENDIF

#IFSAME Language$Current Language$Francais
    Define CS_DUF_CannotLogincConnection for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer    for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText              for "\n\nError Text:"
#ENDIF

#IFSAME Language$Current Language$Italiano
    Define CS_DUF_CannotLogincConnection for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer    for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText              for "\n\nError Text:"
#ENDIF

#IFSAME Language$Current Language$Espanol
    Define CS_DUF_CannotLogincConnection for "No se puede iniciar sesin en el servidor de base de datos ya que la conexin no se ha configurado correctamente. No se puede continuar. El programa ser cerrado."
    Define CS_DUF_CannotLoginToServer    for "No se puede iniciar sesin en el servidor de base de datos. No se puede continuar. El programa ser cerrado."
    Define CS_DUF_ErrorText              for "\n\nTexto del error:"
#ENDIF

#IFSAME Language$Current Language$Norsk
    Define CS_DUF_CannotLogincConnection for "Kan ikke logge på databasetjener, for cConnection er ikke riktig satt opp. Kan ikke fortsette. Programmet avsluttes."
    Define CS_DUF_CannotLoginToServer    for "Kan ikke logge på databasetjener. Kan ikke fortsette. Programmet avsluttes."
    Define CS_DUF_ErrorText              for "\n\nFeilbeskrivelse:"
#ENDIF

#IFSame Language$Current = Language$Russian
    Define CS_DUF_CannotLogincConnection for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer    for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText              for "\n\nError Text:"
#ENDIF

#IFSame Language$Current = Language$Polish
    Define CS_DUF_CannotLogincConnection for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer    for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText              for "\n\nError Text:"
#ENDIF

#IFSame Language$Current = Language$Hungarian
    Define CS_DUF_CannotLogincConnection for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer    for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText              for "\n\nError Text:"
#ENDIF

// *** cDbUpdateFunctionLibrary Class Language Constants ***
//
#IFSAME Language$Current Language$English
    Define CS_SQLConnectError       for "SQL error. Could not connect to the SQL database manager"
    Define CS_SQLAttachError        for "Could not attach to the database:"
    Define CS_SQLDeletingIndex      for "Deleting index"
    Define CS_SQLCopyingData        for "Copying data"
    Define CS_SQLCreatingIndex      for "Creating index"
#ENDIF

#IFSAME Language$Current Language$Nederlands
    Define CS_SQLConnectError       for "SQL fout. Kon geen verbinding maken met de SQL database manager"
    Define CS_SQLAttachError        for "Kan niet aan de database koppelen:"
    Define CS_SQLDeletingIndex      for "Verwijderen index"
    Define CS_SQLCopyingData        for "Kopiren data"
    Define CS_SQLCreatingIndex      for "Aanmaken index"
#ENDIF

#IFSAME Language$Current Language$Svenska
    Define CS_SQLConnectError       for "SQL Fel. Kunde ej f kontakt med SQL Database Manager"
    Define CS_SQLAttachError        for "Fick ej kontakt med databasen:"
    Define CS_SQLDeletingIndex      for "Tar bort index"
    Define CS_SQLCopyingData        for "Kopierar data"
    Define CS_SQLCreatingIndex      for "Skapar index"
#ENDIF

#IFSAME Language$Current Language$Deutsch
    Define CS_SQLConnectError       for "SQL Fehler. Verbindung zum SQL Datenbank Manager nicht mglich."
    Define CS_SQLAttachError        for "Verbindung zur Datenbank fehlgeschlagen:"
    Define CS_SQLDeletingIndex      for "Index lschen"
    Define CS_SQLCopyingData        for "Daten kopieren"
    Define CS_SQLCreatingIndex      for "Index erstellen"
#ENDIF

#IFSAME Language$Current Language$Dansk
    Define CS_SQLConnectError       for "SQL error. Could not connect to the SQL database manager"
    Define CS_SQLAttachError        for "Could not attach to the database:"
    Define CS_SQLDeletingIndex      for "Deleting index"
    Define CS_SQLCopyingData        for "Copying data"
    Define CS_SQLCreatingIndex      for "Creating index"
#ENDIF

#IFSAME Language$Current Language$Portugues
    Define CS_SQLConnectError       for "Erro SQL. No foi possvel conectar-se ao gerenciador de banco de dados SQL"
    Define CS_SQLAttachError        for "No foi possvel anexar-se ao banco de dados:"
    Define CS_SQLDeletingIndex      for "Excluindo ndice"
    Define CS_SQLCopyingData        for "Copiando dados"
    Define CS_SQLCreatingIndex      for "Criando ndice"
#ENDIF

#IFSAME Language$Current Language$Francais
    Define CS_SQLConnectError       for "SQL error. Could not connect to the SQL database manager"
    Define CS_SQLAttachError        for "Could not attach to the database:"
    Define CS_SQLDeletingIndex      for "Deleting index"
    Define CS_SQLCopyingData        for "Copying data"
    Define CS_SQLCreatingIndex      for "Creating index"
#ENDIF

#IFSAME Language$Current Language$Italiano
    Define CS_SQLConnectError       for "SQL error. Could not connect to the SQL database manager"
    Define CS_SQLAttachError        for "Could not attach to the database:"
    Define CS_SQLDeletingIndex      for "Deleting index"
    Define CS_SQLCopyingData        for "Copying data"
    Define CS_SQLCreatingIndex      for "Creating index"
#ENDIF

#IFSAME Language$Current Language$Espanol
    Define CS_SQLConnectError       for "Error SQL. No se puede conectar al administrador de base de datos SQL"
    Define CS_SQLAttachError        for "No se puede adjuntar a la base de datos"
    Define CS_SQLDeletingIndex      for "Eliminando ndice"
    Define CS_SQLCopyingData        for "Copiando datos"
    Define CS_SQLCreatingIndex      for "Creando ndice"
#ENDIF

#IFSAME Language$Current Language$Norsk
    Define CS_SQLConnectError       for "SQL-feil. Kunne ikke koble til SQL-databasebehandler"
    Define CS_SQLAttachError        for "Kunne ikke koble til database:"
    Define CS_SQLDeletingIndex      for "Sletter indeks"
    Define CS_SQLCopyingData        for "Kopierer data"
    Define CS_SQLCreatingIndex      for "Oppretter indeks"
#ENDIF

#IFSame Language$Current = Language$Russian
    Define CS_SQLConnectError       for "SQL error. Could not connect to the SQL database manager"
    Define CS_SQLAttachError        for "Could not attach to the database:"
    Define CS_SQLDeletingIndex      for "Deleting index"
    Define CS_SQLCopyingData        for "Copying data"
    Define CS_SQLCreatingIndex      for "Creating index"
#ENDIF

#IFSame Language$Current = Language$Polish
    Define CS_SQLConnectError       for "SQL error. Could not connect to the SQL database manager"
    Define CS_SQLAttachError        for "Could not attach to the database:"
    Define CS_SQLDeletingIndex      for "Deleting index"
    Define CS_SQLCopyingData        for "Copying data"
    Define CS_SQLCreatingIndex      for "Creating index"
#ENDIF

#IFSame Language$Current = Language$Hungarian
    Define CS_SQLConnectError       for "SQL error. Could not connect to the SQL database manager"
    Define CS_SQLAttachError        for "Could not attach to the database:"
    Define CS_SQLDeletingIndex      for "Deleting index"
    Define CS_SQLCopyingData        for "Copying data"
    Define CS_SQLCreatingIndex      for "Creating index"
#ENDIF

// *** cDbUpdateVersion Class Language Constants ***
//
#IFSAME Language$Current Language$English
    Define CS_UpdateVersion     for "Updating database"
    Define CS_UpdateFromVersion for "from version"
    Define CS_UpdateToVersion   for "to version:"
    Define CS_DbUpdateTableMissing for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
#ENDIF

#IFSAME Language$Current Language$Nederlands
    Define CS_UpdateVersion     for "Bijwerken database"
    Define CS_UpdateFromVersion for "van versie"
    Define CS_UpdateToVersion   for "naar versie:"
    Define CS_DbUpdateTableMissing for "Kan de 'DbVersion' tabel niet openen, die wordt gebruikt bij het bijwerken van de database! Kan niet doorgaan!"
#ENDIF

#IFSAME Language$Current Language$Svenska
    Define CS_UpdateVersion     for "Uppdaterar databas"
    Define CS_UpdateFromVersion for "frn version"
    Define CS_UpdateToVersion   for "till version:"
    Define CS_DbUpdateTableMissing for "Kan inte ppna 'DbVersion' tabellen som anvnds d databasen ska uppdateras! Kan inte fortstta!"
#ENDIF

#IFSAME Language$Current Language$Deutsch
    Define CS_UpdateVersion     for "Datenbank aktualisieren"
    Define CS_UpdateFromVersion for "von Version"
    Define CS_UpdateToVersion   for "auf Version:"
    Define CS_DbUpdateTableMissing for "Kann die Tabelle 'DbVersion' nicht ffnen, die zum Aktualisieren der Datenbank benutzt wird! Fortfahren nicht mglich!"
#ENDIF

#IFSAME Language$Current Language$Dansk
    Define CS_UpdateVersion     for "Updating database"
    Define CS_UpdateFromVersion for "from version"
    Define CS_UpdateToVersion   for "to version:"
    Define CS_DbUpdateTableMissing for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
#ENDIF

#IFSAME Language$Current Language$Portugues
    Define CS_UpdateVersion     for "Atualizando banco de dados"
    Define CS_UpdateFromVersion for "da verso"
    Define CS_UpdateToVersion   for "para a verso:"
    Define CS_DbUpdateTableMissing for "No foi possiel abrir a tabela 'DbVersion' que  utilizada durante o processo de atualizao do banco de dados.! Impossvel continuar!"
#ENDIF

#IFSAME Language$Current Language$Francais
    Define CS_UpdateVersion     for "Updating database"
    Define CS_UpdateFromVersion for "from version"
    Define CS_UpdateToVersion   for "to version:"
    Define CS_DbUpdateTableMissing for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
#ENDIF

#IFSAME Language$Current Language$Italiano
    Define CS_UpdateVersion     for "Updating database"
    Define CS_UpdateFromVersion for "from version"
    Define CS_UpdateToVersion   for "to version:"
    Define CS_DbUpdateTableMissing for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
#ENDIF

#IFSAME Language$Current Language$Espanol
    Define CS_UpdateVersion     for "Actualizando base de datos"
    Define CS_UpdateFromVersion for "desde versin"
    Define CS_UpdateToVersion   for "hasta versin:"
    Define CS_DbUpdateTableMissing for "No se puede abrir la tabla 'DbVersion' que se utiliza al actualizar la base de datos! No se puede continuar!"
#ENDIF

#IFSAME Language$Current Language$Norsk
    Define CS_UpdateVersion     for "Oppdaterer database"
    Define CS_UpdateFromVersion for "fra versjon"
    Define CS_UpdateToVersion   for "til versjon:"
    Define CS_DbUpdateTableMissing for "Kan ikke åpne 'DbVersion'-tabellen som brukes ved oppdatering av databasen! Kan ikke fortsette!"
#ENDIF

#IFSame Language$Current = Language$Russian
    Define CS_UpdateVersion     for "Updating database"
    Define CS_UpdateFromVersion for "from version"
    Define CS_UpdateToVersion   for "to version:"
    Define CS_DbUpdateTableMissing for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
#ENDIF

#IFSame Language$Current = Language$Polish
    Define CS_UpdateVersion     for "Updating database"
    Define CS_UpdateFromVersion for "from version"
    Define CS_UpdateToVersion   for "to version:"
    Define CS_DbUpdateTableMissing for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
#ENDIF

#IFSame Language$Current = Language$Hungarian
    Define CS_UpdateVersion     for "Updating database"
    Define CS_UpdateFromVersion for "from version"
    Define CS_UpdateToVersion   for "to version:"
    Define CS_DbUpdateTableMissing for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
#ENDIF

// *** cDbUpdateHandler.inc Class Language Constants ***
//
#IFSAME Language$Current Language$English
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_HeaderUpdateText    for "Important!"
    Define CS_DatabaseInUseText   for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_WorkingHeaderText   for "Working!"
    Define CS_WorkingUpdateText   for "The database is being updated. Please wait..."
    Define CS_DatabaseUpdatedText for "Ready! The database was updated."
    Define CS_DatabaseCheckedText for "Ready! The database was checked but no updates was needed."
    Define CS_DbUpdatedErrorText  for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_UpdateInProgressTxt for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
#ENDIF

#IFSAME Language$Current Language$Nederlands
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("De database moet worden bijgewerkt." + "\n\nNB! De database mag niet in gebruik zijn, terwijl deze bewerking wordt uitgevoerd. Zorg ervoor dat niemand anders de toepassing gebruikt voordat u hieronder 'Ja' klikt.\n\n" + "Beginnen met bijwerken?")
    Define CS_HeaderUpdateText    for "Belangrijk!"
    Define CS_DatabaseInUseText   for "Er zijn anderen die de applicatie / database gebruiken of tenminste n tabel kan NIET exclusief geopend worden. Sluit alstublieft alle andere applicaties met behulp van de database en probeer het opnieuw. De applicatie zal nu sluiten."
    Define CS_WorkingHeaderText   for "Bezig!"
    Define CS_WorkingUpdateText   for "De database wordt bijgewerkt. Even geduld a.u.b. ..."
    Define CS_DatabaseUpdatedText for "Klaar! De database is bijgewerkt."
    Define CS_DatabaseCheckedText for "Klaar! De database is gecontroleerd, maar er waren geen updates nodig."
    Define CS_DbUpdatedErrorText  for "Er zijn n of meerdere fouten opgetreden tijdens het bijwerken van de database. Controleer het logbestand.\n\nHet programma wordt nu beindigd."
    Define CS_UpdateInProgressTxt for ("Het systeem is vergrendeld!\n\nDe database wordt bijgewerkt. Probeer het later nogmaals...\n\n" * "Het programma wordt nu beindigd.")
#ENDIF

#IFSAME Language$Current Language$Svenska
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("Databasen behver uppdateras." + "\n\nOBS! Databasen fr ej anvndas medan detta arbete sker. Var god och skerstll att ingen annan kr programmet eller p annat stt anvnder databasen som anvnds fr programmet innan du klicka p 'Ja' nedan.\n\n" + "Starta uppdateringen nu?")
    Define CS_HeaderUpdateText    for "Viktigt!"
    Define CS_DatabaseInUseText   for "Det verkar finnas andra personer som kr programmet eller anvnder databasen, eftersom tminstone en tabell ej kunde ppnas exklisivt. Var vnlig stng alla andra applikationer som kan anvnda databasen och frsk igen. Programmet kommer nu att avslutas."
    Define CS_WorkingHeaderText   for "Arbetar!"
    Define CS_WorkingUpdateText   for "Databasen hller p att uppdateras. Var god vnta..."
    Define CS_DatabaseUpdatedText for "Klart! Databasen r nu uppdaterad."
    Define CS_DatabaseCheckedText for "Ready! The database was checked but no updates was needed."
    Define CS_DbUpdatedErrorText  for "Ett eller flera fel uppstod tyvrr under uppdateringen av databasen. Var god kontrollera fel-loggen.\n\nProgrammet kommer nu att avslutas."
    Define CS_UpdateInProgressTxt for ("Systemet r lst!\n\nDatabasen hller p att uppdateras. Var god vnta och frsk ter senare...\n\n" * "Programmet kommer nu att avslutas.")
#ENDIF

#IFSAME Language$Current Language$Deutsch
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("Die Datenbank muss aktualisiert werden." + "\n\nNB! Die Datenbank darf whrend dieses Prozesses nicht in Benutzung sein. Stellen Sie sicher, dass niemand das Programm benutzt, bevor Sie unten 'Ja' klicken.\n\n" + "Jetzt starten?")
    Define CS_HeaderUpdateText    for "Wichtig!"
    Define CS_DatabaseInUseText   for "Andere Benutzer benutzen das Programm/die Datenbank. Zumindest eine Tabelle konnte nicht EXCLUSIV geffnet werden. Bitte schliessen Sie alle anderen Programme, die die Datenbank benutzen und versuchen Sie es erneut. Das Programm wir jetzt beendet."
    Define CS_WorkingHeaderText   for "Arbeite!"
    Define CS_WorkingUpdateText   for "Die Datenbank wird aktualisiert. Bitte warten..."
    Define CS_DatabaseUpdatedText for "Fertig! Die Datenbank ist aktualisiert."
    Define CS_DatabaseCheckedText for "Fertig! Die Datenbank wurde berprft, es ist aber keine Aktualisierung notwendig."
    Define CS_DbUpdatedErrorText  for "Ein oder mehrere Fehler sind whrend der Aktualisierung aufgetreten. Bitte schauen Sie in die Log-Datei.\n\nDas Programm wird jetzt beendet."
    Define CS_UpdateInProgressTxt for ("System gesperrt!\n\nDie Datenbank wird aktualisiert. Bitte versuchen Sie es spter wieder...\n\n" * "Das Programm wird jetzt beendet.")
#ENDIF

#IFSAME Language$Current Language$Dansk
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_HeaderUpdateText    for "Important!"
    Define CS_DatabaseInUseText   for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_WorkingHeaderText   for "Working!"
    Define CS_WorkingUpdateText   for "The database is being updated. Please wait..."
    Define CS_DatabaseUpdatedText for "Ready! The database was updated."
    Define CS_DatabaseCheckedText for "Ready! The database was checked but no updates was needed."
    Define CS_DbUpdatedErrorText  for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_UpdateInProgressTxt for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
#ENDIF

#IFSAME Language$Current Language$Portugues
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("O banco de dados precisa ser atualizado." + "\n\nAteno! O banco de dados no pode ser utilizado enquanto essa tarefa  executada. Certifique-se de que ningum mais esteja utilizando a aplicao antes de clicar em 'Sim' abaixo.\n\n" + "Iniciar a atualizao agora?")
    Define CS_HeaderUpdateText    for "Importante!"
    Define CS_DatabaseInUseText   for "Existem outros usurios usando a aplicao/banco de dados ou pelo menos uma tabela no pde ser aberta em modo exclusivo. Por favor, encerre todas as aplicaes que usam esse banco de dados e tente novamente. Esse Aplicativo ser encerrado agora."
    Define CS_WorkingHeaderText   for "Trabalhando!"
    Define CS_WorkingUpdateText   for "O banco de dados est sendo atualizado. Por favor aguarde ..."
    Define CS_DatabaseUpdatedText for "Pronto! O banco de dados foi atualizado."
    Define CS_DatabaseCheckedText for "Pronto! O banco de dados foi verificado mas nenhuma atualizao era necessria."
    Define CS_DbUpdatedErrorText  for "Um ou mais erros aconteceram enquanto o banco de dados era atualizado. Por favor verifique o arquivo de log.\n\nO programa ser encerrado."
    Define CS_UpdateInProgressTxt for ("Sistema bloqueado!\n\nO banco de dados est sendo atualizado. Por favor tente novamente mais tarde...\n\n" * "O programa ser encerrado.")
#ENDIF

#IFSAME Language$Current Language$Francais
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_HeaderUpdateText    for "Important!"
    Define CS_DatabaseInUseText   for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_WorkingHeaderText   for "Working!"
    Define CS_WorkingUpdateText   for "The database is being updated. Please wait..."
    Define CS_DatabaseUpdatedText for "Ready! The database was updated."
    Define CS_DatabaseCheckedText for "Ready! The database was checked but no updates was needed."
    Define CS_DbUpdatedErrorText  for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_UpdateInProgressTxt for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
#ENDIF

#IFSAME Language$Current Language$Italiano
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_HeaderUpdateText    for "Important!"
    Define CS_DatabaseInUseText   for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_WorkingHeaderText   for "Working!"
    Define CS_WorkingUpdateText   for "The database is being updated. Please wait..."
    Define CS_DatabaseUpdatedText for "Ready! The database was updated."
    Define CS_DatabaseCheckedText for "Ready! The database was checked but no updates was needed."
    Define CS_DbUpdatedErrorText  for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_UpdateInProgressTxt for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
#ENDIF

#IFSAME Language$Current Language$Espanol
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("La base de datos necesita ser actualizada." + "\n\nNB! La base datos no puede estar en uso mientras se ejecuta esta tarea. Asegrese de que nadie ms est usando la aplicacin antes de hacer clic en 'S'.\n\n" + "Iniciar actualizacin ahora")
    Define CS_HeaderUpdateText    for "Importante!"
    Define CS_DatabaseInUseText   for "Hay otros utilizando la aplicacin / base de datos o por lo menos una tabla. No se pudo abrir exclusivamente. Cierre todas las dems aplicaciones que utilizan la base de datos y vuelva a intentarlo. La aplicacin se cerrar ahora."
    Define CS_WorkingHeaderText   for "Trabajando!"
    Define CS_WorkingUpdateText   for "a base de datos se esta actualizando. Por favor espere..."
    Define CS_DatabaseUpdatedText for "Listo! La base de datos fue actualizada."
    Define CS_DatabaseCheckedText for "Listo! Se verific la base de datos y no fue necesario actualizar."
    Define CS_DbUpdatedErrorText  for "Uno o ms errores ocurrieron mientras se actualizaba la base de datos. Por favor verifique el archivo de registro.\n\nEl programa ser cerrado ahora."
    Define CS_UpdateInProgressTxt for ("Sistema bloqueado!\n\nLa base de datos est siendo actualizada. Por favor, intntelo de nuevo ms tarde...\n\n" * "El programa ser cerrado ahora.")
#ENDIF

#IFSAME Language$Current Language$Norsk
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("Database må oppdateres." + "\n\nNB! Databasen må ikke være i bruk mens dette pågår. Påse at ingen andre bruker databasen/programmet før du velger 'Ja' nedenfor.\n\n" + "Starte oppdatering nå?")
    Define CS_HeaderUpdateText    for "Viktig!"
    Define CS_DatabaseInUseText   for "Andre bruker programmet/databasen, eller minst en tabell kunne IKKE åpnes eksklusivt. Steng alle andre programmer som bruker databasen og forsøk igjen. Programmet avsluttes nå."
    Define CS_WorkingHeaderText   for "Arbeider!"
    Define CS_WorkingUpdateText   for "Databasen oppdateres. Vennligst vent..."
    Define CS_DatabaseUpdatedText for "Klar! Databasen ble oppdatert."
    Define CS_DatabaseCheckedText for "Klar! Database ble sjekket, men ingen oppdatering var nødvendig."
    Define CS_DbUpdatedErrorText  for "En eller flere feil oppsto under oppdatering av databasen. Sjekk loggfil.\n\nProgrammet avsluttes."
    Define CS_UpdateInProgressTxt for ("System låst!\n\nDatabasen blir oppdatert. Prøv igjen senere...\n\n" * "Programmet avsluttes.")
#ENDIF

#IFSame Language$Current = Language$Russian
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_HeaderUpdateText    for "Important!"
    Define CS_DatabaseInUseText   for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_WorkingHeaderText   for "Working!"
    Define CS_WorkingUpdateText   for "The database is being updated. Please wait..."
    Define CS_DatabaseUpdatedText for "Ready! The database was updated."
    Define CS_DatabaseCheckedText for "Ready! The database was checked but no updates was needed."
    Define CS_DbUpdatedErrorText  for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_UpdateInProgressTxt for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
#ENDIF

#IFSame Language$Current = Language$Polish
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_HeaderUpdateText    for "Important!"
    Define CS_DatabaseInUseText   for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_WorkingHeaderText   for "Working!"
    Define CS_WorkingUpdateText   for "The database is being updated. Please wait..."
    Define CS_DatabaseUpdatedText for "Ready! The database was updated."
    Define CS_DatabaseCheckedText for "Ready! The database was checked but no updates was needed."
    Define CS_DbUpdatedErrorText  for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_UpdateInProgressTxt for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
#ENDIF

#IFSame Language$Current = Language$Hungarian
    Define CS_DatabaseInUseShort  for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DatabaseNeedsUpdate for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_HeaderUpdateText    for "Important!"
    Define CS_DatabaseInUseText   for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_WorkingHeaderText   for "Working!"
    Define CS_WorkingUpdateText   for "The database is being updated. Please wait..."
    Define CS_DatabaseUpdatedText for "Ready! The database was updated."
    Define CS_DatabaseCheckedText for "Ready! The database was checked but no updates was needed."
    Define CS_DbUpdatedErrorText  for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_UpdateInProgressTxt for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
#ENDIF
